package com.ruoyi.common.core.web.controller;

import com.github.pagehelper.PageInfo;
import com.ruoyi.common.core.constant.Constants;
import com.ruoyi.common.core.constant.HttpStatus;
import com.ruoyi.common.core.utils.*;
import com.ruoyi.common.core.web.domain.AjaxResult;
import com.ruoyi.common.core.web.domain.GenericsAjaxResult;
import com.ruoyi.common.core.web.page.GenericsTableDataInfo;
import com.ruoyi.common.core.web.page.PageDomain;
import com.ruoyi.common.core.web.page.TableDataInfo;
import com.ruoyi.common.core.web.page.TableSupport;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.web.bind.WebDataBinder;
import org.springframework.web.bind.annotation.InitBinder;

import java.beans.PropertyEditorSupport;
import java.util.Date;
import java.util.List;

/**
 * web层通用数据处理
 *
 * @author ruoyi
 */
public class BaseController {
    protected final Logger logger = LoggerFactory.getLogger(this.getClass());

    /**
     * 将前台传递过来的日期格式的字符串，自动转化为Date类型
     */
    @InitBinder
    public void initBinder(WebDataBinder binder) {
        // Date 类型转换
        binder.registerCustomEditor(Date.class, new PropertyEditorSupport() {
            @Override
            public void setAsText(String text) {
                setValue(DateUtils.parseDate(text));
            }
        });
    }

    /**
     * 设置请求分页数据
     */
    protected void startPage() {
        PageUtils.startPage();
    }

    /**
     * 清理分页的线程变量
     */
    protected void clearPage() {
        PageUtils.clearPage();
    }

    /**
     * 响应请求分页数据
     */
    @SuppressWarnings({"rawtypes", "unchecked"})
    protected TableDataInfo getDataTable(List<?> list) {
        TableDataInfo rspData = new TableDataInfo();
        rspData.setCode(HttpStatus.SUCCESS);
        rspData.setRows(list);
        rspData.setMsg("查询成功");
        rspData.setTotal(new PageInfo(list).getTotal());
        return rspData;
    }

    /**
     * 响应请求分页数据
     */
    @SuppressWarnings({"rawtypes", "unchecked"})
    protected <T> GenericsTableDataInfo<T> getGenericsDataTable(List<T> list) {
        GenericsTableDataInfo<T> rspData = new GenericsTableDataInfo<>();
        rspData.setCode(HttpStatus.SUCCESS);
        rspData.setRows(list);
        rspData.setMsg("查询成功");
        rspData.setTotal(new PageInfo(list).getTotal());
        return rspData;
    }

    /**
     * 响应请求分页数据
     */

    protected <T> GenericsTableDataInfo<T> getGenericsDataTable(List<T> list, Integer count) {
        GenericsTableDataInfo<T> rspData = new GenericsTableDataInfo<>();
        rspData.setCode(HttpStatus.SUCCESS);
        rspData.setRows(list);
        rspData.setMsg("查询成功");
        rspData.setTotal(count);
        return rspData;
    }

    /**
     * 响应请求分页数据
     */
    protected <T> GenericsTableDataInfo<T> getAllGenericsDataTableToPage(List<T> list) {
        GenericsTableDataInfo<T> rspData = new GenericsTableDataInfo<>();
        rspData.setCode(HttpStatus.SUCCESS);
        int total = list.size();
        rspData.setTotal(total);
        String orderByStr = ServletUtils.getParameter(Constants.ORDER_BY_COLUMN);
        if (StringUtils.isNotEmpty(orderByStr)) {
            String isAscStr = ServletUtils.getParameter(Constants.IS_ASC);
            if (StringUtils.isNotEmpty(orderByStr)) {
                String ascString = "asc";
                boolean isAsc = true;
                if (isAscStr != null && !ascString.equals(isAscStr.toLowerCase())) {
                    isAsc = false;
                }
                SortUtils.sort(list, orderByStr, isAsc);
            }
        }
        if (StringUtils.isNotEmpty(ServletUtils.getParameter(Constants.PAGE_NUM))
                && StringUtils.isNotEmpty(ServletUtils.getParameter(Constants.PAGE_SIZE))) {
            PageDomain pageDomain = TableSupport.buildPageRequest();
            Integer pageNum = pageDomain.getPageNum();
            Integer pageSize = pageDomain.getPageSize();

            if (pageNum != null && pageSize != null) {
                if (pageNum > 0) {
                    pageNum = pageNum - 1;
                } else {
                    pageNum = 0;
                }
                int startIndex = pageNum * pageSize;
                int endIndex = (pageNum + 1) * pageSize;

                int currentSize = total - startIndex;
                if (currentSize < pageSize && currentSize > 0) {
                    endIndex = startIndex + currentSize;
                } else if (currentSize <= 0) {
                    if (total > pageSize) {
                        startIndex = total - pageSize - 1;
                    } else {
                        startIndex = 0;
                        endIndex = total;
                    }

                }
                list = list.subList(startIndex, endIndex);
            }
            //todo:暂不考虑        Boolean reasonable = pageDomain.getReasonable();
        }

        rspData.setRows(list);
        rspData.setMsg("查询成功");
        return rspData;
    }

    /**
     * 响应请求分页数据
     */
    @SuppressWarnings({"rawtypes", "unchecked"})
    protected TableDataInfo getDataTable(List<?> list, Integer size) {
        TableDataInfo rspData = new TableDataInfo();
        rspData.setCode(HttpStatus.SUCCESS);
        rspData.setRows(list);
        rspData.setMsg("查询成功");
        rspData.setTotal(size);
        return rspData;
    }

    /**
     * 返回成功
     */
    public AjaxResult success() {
        return AjaxResult.success();
    }

    /**
     * 返回成功消息
     */
    public AjaxResult success(String message) {
        return AjaxResult.success(message);
    }

    /**
     * 返回成功消息
     */
    public AjaxResult success(Object data) {
        return AjaxResult.success(data);
    }

    /**
     * 返回成功消息
     */
    public <T> GenericsAjaxResult<T> genericsSuccess(T data) {
        return GenericsAjaxResult.success(data);
    }

    /**
     * 返回失败消息
     */
    public AjaxResult error() {
        return AjaxResult.error();
    }

    /**
     * 返回失败消息
     */
    public AjaxResult error(String message) {
        return AjaxResult.error(message);
    }

    /**
     * 返回警告消息
     */
    public AjaxResult warn(String message) {
        return AjaxResult.warn(message);
    }

    /**
     * 响应返回结果
     *
     * @param rows 影响行数
     * @return 操作结果
     */
    protected AjaxResult toAjax(int rows) {
        return rows > 0 ? AjaxResult.success() : AjaxResult.error();
    }

    /**
     * 响应返回结果
     *
     * @param rows 影响行数
     * @return 操作结果
     */
    protected <T> GenericsAjaxResult<T> toGenericsAjax(int rows) {
        return rows > 0 ? GenericsAjaxResult.success() : GenericsAjaxResult.error();
    }

    /**
     * 响应返回结果
     *
     * @param data 数据
     * @return 操作结果
     */
    protected <T> GenericsAjaxResult<T> successToGenericsAjax(T data) {
        return GenericsAjaxResult.success(data);
    }

    /**
     * 响应返回结果
     *
     * @param result 结果
     * @return 操作结果
     */
    protected AjaxResult toAjax(boolean result) {
        return result ? success() : error();
    }
}
